function loadData(name)
{
   obj.loaded = false;
   obj.loadVariables(name);
}
function rotate3D(i, xa, ya)
{
   var cosYangle = Math.cos(ya * rad);
   var sinYangle = Math.sin(ya * rad);
   var cosXangle = Math.cos(xa * rad);
   var sinXangle = Math.sin(xa * rad);
   var tempz = v[i].z * cosYangle - v[i].x * sinYangle;
   var tmpx = v[i].z * sinYangle + v[i].x * cosYangle;
   var tmpz = v[i].y * sinXangle + tempz * cosXangle;
   var tmpy = v[i].y * cosXangle - tempz * sinXangle;
   v[i].x = tmpx;
   v[i].y = tmpy;
   v[i].z = tmpz;
}
function putFace(index)
{
   var x1 = v[f[index].a].x + startx;
   var y1 = v[f[index].a].y + starty;
   var z1 = v[f[index].a].z + startz;
   var zratio1 = dist / (z1 + dist);
   var xscr1 = 300 + x1 * zratio1;
   var yscr1 = 300 - y1 * zratio1;
   var x2 = v[f[index].b].x + startx;
   var y2 = v[f[index].b].y + starty;
   var z2 = v[f[index].b].z + startz;
   var zratio2 = dist / (z2 + dist);
   var xscr2 = 300 + x2 * zratio2;
   var yscr2 = 300 - y2 * zratio2;
   var x3 = v[f[index].c].x + startx;
   var y3 = v[f[index].c].y + starty;
   var z3 = v[f[index].c].z + startz;
   var zratio3 = dist / (z3 + dist);
   var xscr3 = 300 + x3 * zratio3;
   var yscr3 = 300 - y3 * zratio3;
   var clockwize = (xscr2 - xscr1) * (yscr3 - yscr1) - (xscr3 - xscr1) * (yscr2 - yscr1) >= 0;
   if(clockwize)
   {
      f[index].hidden = false;
   }
   else
   {
      f[index].hidden = true;
   }
   if(fill.GetState())
   {
      f[index].z = (z1 + z2 + z3) / 3;
      var sortflag = false;
      i = 0;
      while(i < index && !sortflag)
      {
         if(f[i].z < f[index].z)
         {
            k = index;
            while(i < k)
            {
               f[k].zindex = f[k - 1].zindex;
               k--;
            }
            f[i].zindex = index;
            sortflag = true;
         }
         i++;
      }
      if(!sortflag)
      {
         f[index].zindex = index;
      }
      f[index].x1 = xscr1;
      f[index].y1 = yscr1;
      if(clockwize)
      {
         f[index].x2 = xscr2;
         f[index].y2 = yscr2;
         f[index].x3 = xscr3;
         f[index].y3 = yscr3;
      }
      else
      {
         f[index].x2 = xscr3;
         f[index].y2 = yscr3;
         f[index].x3 = xscr2;
         f[index].y3 = yscr2;
      }
   }
   if(clockwize || hidden.GetState())
   {
      if(lines.GetState())
      {
         var name = "ln" + ldepth;
         _root.attachMovie("line",name,ldepth++);
         _root[name]._x = xscr1;
         _root[name]._y = yscr1;
         _root[name]._xscale = xscr2 - xscr1;
         _root[name]._yscale = yscr2 - yscr1;
         var name = "ln" + ldepth;
         _root.attachMovie("line",name,ldepth++);
         _root[name]._x = xscr2;
         _root[name]._y = yscr2;
         _root[name]._xscale = xscr3 - xscr2;
         _root[name]._yscale = yscr3 - yscr2;
         var name = "ln" + ldepth;
         _root.attachMovie("line",name,ldepth++);
         _root[name]._x = xscr3;
         _root[name]._y = yscr3;
         _root[name]._xscale = xscr1 - xscr3;
         _root[name]._yscale = yscr1 - yscr3;
      }
      if(dots.GetState())
      {
         var name = "v" + vdepth;
         _root.attachMovie("vertex",name,vdepth++);
         _root[name]._x = xscr1;
         _root[name]._y = yscr1;
         _root[name]._yscale = _root[name]._xscale = 100 * zratio1;
         var name = "v" + vdepth;
         _root.attachMovie("vertex",name,vdepth++);
         _root[name]._x = xscr2;
         _root[name]._y = yscr2;
         _root[name]._yscale = _root[name]._xscale = 100 * zratio2;
         var name = "v" + vdepth;
         _root.attachMovie("vertex",name,vdepth++);
         _root[name]._x = xscr3;
         _root[name]._y = yscr3;
         _root[name]._yscale = _root[name]._xscale = 100 * zratio3;
      }
   }
}
function drawTriangle(index)
{
   if(fill.GetState() && !f[index].hidden)
   {
      pt = new Array();
      pt[0] = new object();
      pt[1] = new object();
      pt[2] = new object();
      pt[0].x = f[index].x1;
      pt[0].y = f[index].y1;
      pt[1].x = f[index].x2;
      pt[1].y = f[index].y2;
      pt[2].x = f[index].x3;
      pt[2].y = f[index].y3;
      var order = [0,1,2];
      var distances = new Array();
      distances[0] = Math.sqrt((pt[1].x - pt[2].x) * (pt[1].x - pt[2].x) + (pt[1].y - pt[2].y) * (pt[1].y - pt[2].y));
      distances[1] = Math.sqrt((pt[2].x - pt[0].x) * (pt[2].x - pt[0].x) + (pt[2].y - pt[0].y) * (pt[2].y - pt[0].y));
      distances[2] = Math.sqrt((pt[0].x - pt[1].x) * (pt[0].x - pt[1].x) + (pt[0].y - pt[1].y) * (pt[0].y - pt[1].y));
      order[0] = distances[2] >= distances[0] ? (distances[1] < distances[2]) + 1 : distances[0] < distances[1];
      order[0] *= 1;
      order[order[0]] = 0;
      var a = order[0];
      var b = order[1];
      var c = order[2];
      var opp = pt[c].y - pt[a].y;
      var adj = pt[a].x - pt[c].x;
      var angle_0_2 = triArcTan(opp,adj);
      var opp = pt[c].y - pt[b].y;
      var adj = pt[b].x - pt[c].x;
      var angle_1_2 = triArcTan(opp,adj);
      var name = "ft" + fdepth;
      _root.attachMovie("triangle",name,fdepth++);
      _root[name]._x = pt[a].x;
      _root[name]._y = pt[a].y;
      _root[name]._xscale = distances[a];
      var ang3 = angle_1_2 - angle_0_2;
      _root[name]._yscale = Math.sin(ang3 / 180 * 3.14159265358979) * distances[b];
      _root[name]._rotation = angle_1_2 + 90;
      var skew = 1 - Math.sin((90 - ang3) / 180 * 3.14159265358979) * distances[b] / distances[a];
      var skewPos = Math.round(skew * 1000);
      _root[name].gotoAndStop(skewPos);
      return _root[name];
   }
}
function triArcTan(opp, adj)
{
   var angBase = Math.atan(opp / adj) * 180 / 3.14159265358979;
   if(opp >= 0 && adj >= 0)
   {
      angBase = 90 - angBase + 180;
   }
   else if(opp < 0 && adj >= 0)
   {
      angBase = Math.abs(angBase) + 270;
   }
   else if(opp < 0 && adj < 0)
   {
      angBase = 90 - angBase;
   }
   else if(opp >= 0 && adj < 0)
   {
      angBase = Math.abs(angBase) + 90;
   }
   return angBase;
}
rad = 0.017453292519943295;
dist = 200;
startx = starty = startz = 0;
fscommand("allowscale","false");
stop();
